%global gitversion 8ea71e62442098a5dc4e3b87d9ec66b00c387e18

Name: libopenzwave
Group: Productivity/Networking/Other
Summary: Library to access Z-Wave interfaces
URL:http://code.google.com/p/open-zwave/
License: LGPLv3+
Version: 1.6.1869
Release: 1%{dist}
BuildRequires: gcc-c++ make doxygen graphviz
BuildRequires: systemd-devel pkgconfig
Requires(pre): shadow-utils
Source0: %{gitversion}.zip

BuildRoot: %{_tmppath}/open-zwave-%{gitversion}

%description
OpenZWave is an open-source, cross-platform library designed to enable anyone to
add support for Z-Wave home-automation devices to their applications, without 
requiring any in depth knowledge of the Z-Wave protocol.

Z-Wave employs a proprietary protocol which the owners, Sigma Designs, have 
chosen to release a large portion (not all) into the public domain. Prior to
Sept, 2016, OpenZWave was developed by mainly reverse engineering the protocol
as well as consulting various public information on the Internet.

The goal of the project is to make a positive contribution to the Z-Wave 
community by creating a library that supports as much of the Z-Wave 
specification as possible, and that can be used as a "black-box" solution 
by anyone wanting to add Z-Wave to their application. It is NOT our aim 
to publish alternative documentation of the Z-Wave protocol.

%package -n libopenzwave-devel
Summary: Open-ZWave header files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description -n libopenzwave-devel
header files needed when you want to compile your own 
applications using openzwave

%package -n openzwave
Summary: Open-ZWave Sample Executables
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description -n openzwave
Sample Executables for OpenZWave

%prep

%setup -q -n open-zwave-%{gitversion}

sed -i 's/^RELEASE_CFLAGS.*/RELEASE_CFLAGS :=/' cpp/build/Makefile
sed -i 's/^RELEASE_CFLAGS.*/RELEASE_CFLAGS :=/' cpp/examples/MinOZW/Makefile

%build
major_ver=$(echo %{version} | awk -F \. {'print $1'})
minor_ver=$(echo %{version} | awk -F \. {'print $2'})
revision=$(echo %{version} | awk -F \. {'print $3'})
longversion=%{version}-%{release}
CFLAGS="-fPIC -DNDEBUG -std=c++11 -Wformat %{optflags} '-DSYSCONFDIR=\"%{_sysconfdir}/openzwave/config\"' -DOPENZWAVE_ENABLE_EXCEPTIONS" \
LDFLAGS="%{__global_ldflags}" \
VERSION_MAJ=$major_ver \
VERSION_MIN=$minor_ver \
VERSION_REV=$revision \
GITVERSION=$longversion \
PREFIX=/usr \
sysconfdir=%{_datadir}/openzwave/config \
includedir=%{_includedir} \
docdir=%{_defaultdocdir}/openzwave-%{version} \
instlibdir=%{_libdir} \
pkgconfigdir=%{_libdir}/pkgconfig/ \
USE_BI_TXML=1 \
make %{?_smp_mflags} SHELL='sh -x'

%install
rm -rf %{buildroot}/*
major_ver=$(echo %{version} | awk -F \. {'print $1'})
minor_ver=$(echo %{version} | awk -F \. {'print $2'})
revision=$(echo %{version} | awk -F \. {'print $3'})
longversion=%{version}-%{release}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_defaultdocdir}/openzwave-%{version}/
mkdir -p %{buildroot}%{_sysconfdir}/
mkdir -p %{buildroot}%{_includedir}/openzwave/
DESTDIR=%{buildroot} \
VERSION_MAJ=$major_ver \
VERSION_MIN=$minor_ver \
VERSION_REV=$revision \
GITVERSION=$longversion \
PREFIX=/usr \
sysconfdir=%{_datadir}/openzwave/config \
includedir=%{_includedir}/openzwave/ \
docdir=%{_defaultdocdir}/openzwave-%{version} \
instlibdir=%{_libdir} \
pkgconfigdir=%{_libdir}/pkgconfig/ \
USE_BI_TXML=1 \
make install
rm %{buildroot}%{_defaultdocdir}/openzwave-%{version}/Doxyfile.in
rm -rf %{buildroot}%{_defaultdocdir}/openzwave-%{version}/html/
rm -rf %{buildroot}%{_defaultdocdir}/openzwave-%{version}/default.htm
rm -rf %{buildroot}%{_defaultdocdir}/openzwave-%{version}/general/
rm -rf %{buildroot}%{_defaultdocdir}/openzwave-%{version}/images+css/
rm -rf %{buildroot}%{_defaultdocdir}/openzwave-%{version}/api/
rm -f %{buildroot}%{_defaultdocdir}/openzwave-%{version}/ChangeLog.old


%files
%defattr(-,root,root,-)
%license licenses/*.txt
%{_libdir}/libopenzwave.so.*
#%dir %{_defaultdocdir}/openzwave-%{version}
#%doc %{_defaultdocdir}/openzwave-%{version}/default.htm
#%doc %{_defaultdocdir}/openzwave-%{version}/general/
#%doc %{_defaultdocdir}/openzwave-%{version}/images+css/
#%doc %{_defaultdocdir}/openzwave-%{version}/license/
#%doc %{_defaultdocdir}/openzwave-%{version}/INSTALL
%attr(775, -, -) %config(noreplace) %{_datadir}/openzwave/config/


%files -n libopenzwave-devel
%defattr(-,root,root,-)
%{_includedir}/openzwave/
%{_libdir}/libopenzwave.so
%{_libdir}/pkgconfig/libopenzwave.pc
%{_bindir}/ozw_config
# %dir %{_defaultdocdir}/openzwave-%{version}
# %doc %{_defaultdocdir}/openzwave-%{version}/api/

%files -n openzwave
%defattr(-,root,root,-)
%{_bindir}/MinOZW

%post
/sbin/ldconfig 
systemctl try-restart domoticz > /dev/null 2>&1 || :

%post -n libopenzwave-devel
/sbin/ldconfig 

%postun
/sbin/ldconfig
if [ $1 -eq 0 ] ; then
rm -rf /usr/share/openzwave > /dev/null 2>&1 || :
fi

%posttrans
unlink /usr/share/open-zwave-read-only > /dev/null 2>&1 || :
unlink /usr/share/open-zwave/open-zwave > /dev/null 2>&1 || :
unlink /usr/share/open-zwave/open-zwave/config/config > /dev/null 2>&1 || :
unlink /usr/share/open-zwave/openzwave/config/config > /dev/null 2>&1 || :
unlink /usr/share/open-zwave/config/config > /dev/null 2>&1 || :
rmdir /usr/share/open-zwave/config > /dev/null 2>&1 || :  # Remove dir if empty and exist
rmdir /usr/share/open-zwave > /dev/null 2>&1 || :  # Remove dir if empty and exist

%changelog
* Wed Apr 14 2021 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1869-1
- Updated upstream

* Thu Apr 8 2021 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1867-1
- Updated upstream

* Sun May 24 2020 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1132-2
- Fix so that Domoticz will display openzwave version

* Sat May 23 2020 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1132-1
- Updated upstream

* Sat May 9 2020 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1114-3
- Final fix of posttrans errors if directories does not exist

* Fri May 8 2020 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1114-2
- Fixed error in posttrans if directory does not exist

* Sun May 3 2020 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1114-1
- Updated upstream
- New installation directory to match new setup in domoticz

* Sun Apr 12 2020 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.6.1074-1
- Updated upstream

* Sun May 26 2019 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.8-1
- Updated upstream

* Wed Aug 15 2018 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.7-1
- Added patch for CentralScene Command Class
- Updated upstream

* Sat Jun 23 2018 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.6-1
- Updated upstream

* Sun Apr 29 2018 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.5-2
- New build attempt after ClearOS Koji reconfig

* Sat Apr 28 2018 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.5-1
- Updated upstream

* Mon Aug 7 2017 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.4-1
- Updated upstream

* Sun Feb 12 2017 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.3-1
- Updated upstream

* Sun Jan 15 2017 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.2-2
- Updated upstream
- Removed read-only soft link as it is not needed for Domoticz
- Added conditional restart of domoticz daemon if it exists and is running
- Fine tuned the uninstall so that the open-zwave directory is always removed

* Sun Jan 8 2017 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.2-1
- Updated upstream
- Major change of installation directories as previous version did not work for all scenarios
- Made post script more robust

* Sat Dec 3 2016 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.1-2
- Updated upstream

* Thu Dec 1 2016 Fredrik Fornstad <fredrik.fornstad@gmail.com> - 1.5.1-1
- First build for ClearOS

* Fri Jun 21 2013 justin@dynam.ac
  Add MultiInstance.patch to handle buggy devices such as Vitrum that
  send wrong commands
* Fri Jun 21 2013 justin@dynam.ac
  Remove debug output from RPM installation commands-
* Fri Jun 21 2013 justin@dynam.ac
  Initial RPM Packages that should work for all Platforms
-
